    //+------------------------------------------------------------------+
    //| Custom MACD.mq4 |
    //| Copyright ? 2004, MetaQuotes Software Corp. |
    //| http://www.metaquotes.net/ |
    //+------------------------------------------------------------------+
    #property copyright "Copyright ? 2004, MetaQuotes Software Corp."
    #property link "http://www.metaquotes.net/"
    //---- indicator settings
    #property indicator_separate_window
    #property indicator_buffers 1
    #property indicator_color1 Silver
    #property indicator_color2 Red
    #property indicator_width1 2
    //---- indicator parameters
    extern int LookbackPeriod = 20;
    //extern int FastEMA=12;
    //extern int SlowEMA=26;
    //extern int SignalSMA=9;
    //---- indicator buffers
    //double MacdBuffer[];
    //double SignalBuffer[];
    double IchiBuffer[],SignalBuffer[];

    //+------------------------------------------------------------------+
    //| Custom indicator initialization function |
    //+------------------------------------------------------------------+
    int init()
    {
    IndicatorBuffers(2);
    //---- drawing settings
    SetIndexStyle(0,DRAW_LINE);
    SetIndexStyle(1,DRAW_LINE);
    //SetIndexDrawBegin(1,SignalSMA);
    IndicatorDigits(Digits+1);
    //---- indicator buffers mapping
    SetIndexBuffer(0,IchiBuffer);
    SetIndexBuffer(1,SignalBuffer);
    //---- name for DataWindow and indicator subwindow label
    IndicatorShortName("IchiHistogram");
    SetIndexLabel(0,"IchiHistogram");
    //SetIndexLabel(1,"Signal");
    //---- initialization done
    return(0);
    }
    //+------------------------------------------------------------------+
    //| Moving Averages Convergence/Divergence |
    //+------------------------------------------------------------------+
    int start()
    {
    int limit;
    int counted_bars=IndicatorCounted();
    //---- last counted bar will be recounted
    if(counted_bars < 0)
    return;
    else counted_bars++;

    if (counted_bars < LookbackPeriod)
    limit = Bars - LookbackPeriod - 1;
    else limit = Bars - counted_bars;

    //---- macd counted in the 1-st buffer
    // for(int i=0; i<limit; i++)
    // MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);
    for(int i=limit; i>=0; i--)
    SignalBuffer[i]=iClose(NULL,0,i) - iIchimoku(NULL,0,9,26,52,MODE_KIJUNSEN,i);
    for(i=limit; i>=0; i--)
    IchiBuffer[i] = 100 * (SignalBuffer[i] - SignalBuffer[ArrayMinimum(SignalBuffer,LookbackPeriod,i)])
    / (SignalBuffer[ArrayMaximum(SignalBuffer,LookbackPeriod,i)] - SignalBuffer[ArrayMinimum(SignalBuffer,LookbackPeriod,i)]);
    // (NULL,0,9,26,52,MODE_KIJUNSEN,i)

    //---- signal line counted in the 2-nd buffer
    //for(i=0; i<limit; i++)
    //SignalBuffer[i]=iMAOnArray(MacdBuffer,Bars,SignalSMA,0,MODE_SMA,i );
    //---- done
    return(0);
    }
    //+------------------------------------------------------------------+ 


